package com.gydx.controller;


import com.gydx.demo.Result;
import com.gydx.service.BiddingMesService;
import com.gydx.vo.BiddingMesVO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/BiddingMes")

@CrossOrigin //解决跨域问题
public class BiddingMesController {


    private static final Logger log = LoggerFactory.getLogger(BiddingMesController.class);
    @Autowired
    BiddingMesService biddingMesService;

    @RequestMapping("/add")
    public Integer addBiddingMes(BiddingMesVO vo) {
        System.out.println(vo.getBiddingStartTime());
        return biddingMesService.saveBiddingMes(vo);
    }

    @RequestMapping("/query")
    public List queryBiddingMes(BiddingMesVO vo) {
        return biddingMesService.findBiddingMes(vo);
    }

    @RequestMapping("/queryByName")
    public List queryBiddingMesByName(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByName(vo);
    }

    @RequestMapping("/queryByStart")
    public List queryBiddingMesByStart(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByStart(vo);
    }

    @RequestMapping("/queryByEnd")
    public List queryBiddingMesByEnd(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByEnd(vo);
    }

    @RequestMapping("/queryByInvoiceType")
    public List queryBiddingMesByInvoiceType(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByInvoiceType(vo);
    }

    @RequestMapping("/queryByPaymentTime")
    public List queryBiddingMesByPaymentTime(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByPaymentTime(vo);
    }

    @RequestMapping("/queryByBiddingStatus")
    public List queryBiddingMesByBiddingStatus(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByBiddingStatus(vo);
    }

    @RequestMapping("/queryByID")
    public List queryBiddingMesByID(BiddingMesVO vo) {
        return biddingMesService.findBiddingMesByID(vo);
    }

    @RequestMapping("/delete")
    public Result removeBiddingMes(BiddingMesVO vo) {
        biddingMesService.removeBiddingMes(vo);
        return Result.success();
    }

    @RequestMapping("/update")
    public String updateBiddingMes(BiddingMesVO vo) {
        biddingMesService.updateBiddingMes(vo);
        return"succ";
    }

    @RequestMapping("EndRoundBiddingMes")
    public Result endRoundBiddingMes(BiddingMesVO biddingMesVO) {
        return Result.success(biddingMesService.endRoundBiddingMes(biddingMesVO));
    }

}
