package com.gydx.controller;

import com.gydx.demo.Result;
import com.gydx.service.BiddingProcessService;
import com.gydx.vo.BiddingProcessVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/BiddingProcess")
public class BiddingProcessController {

    @Autowired
    BiddingProcessService biddingProcessService;

    @RequestMapping("queryAllBP")
    public Result queryAllBP(BiddingProcessVO biddingProcessVO) {
        return Result.success(biddingProcessService.queryAllBP(biddingProcessVO));
    }

    @RequestMapping("queryAllByBiddingMesID")
    public Result queryAllByBiddingMesID(BiddingProcessVO biddingProcessVO) {
        return Result.success(biddingProcessService.queryAllByBiddingMesID(biddingProcessVO));
    }

    @RequestMapping("insertProcessMes")
    public Result insertProcessMes(BiddingProcessVO biddingProcessVO) {
        if (biddingProcessService.insertProcessMes(biddingProcessVO) == 1){
            return Result.success(biddingProcessService.insertProcessMes(biddingProcessVO));
        }else {
            return Result.error("您已经报过价了，不能重复报价");
        }
    }

    @RequestMapping("updateProcessMes")
    public Result updateProcessMes(BiddingProcessVO biddingProcessVO) {
        //1.请求这个供应商的所有报价数
        BiddingProcessVO vo = biddingProcessService.queryBPByMesIDSupId(biddingProcessVO);
        if (vo != null && vo.getBRoundPrice() == null && biddingProcessVO.getBRoundPrice() != null) {
            //第二轮第一次报价
            return Result.success(biddingProcessService.updateProcessMes(biddingProcessVO));
        } else if (vo != null && vo.getCRoundPrice() == null && biddingProcessVO.getCRoundPrice() != null) {
            //第三轮第一次报价
            return Result.success(biddingProcessService.updateProcessMes(biddingProcessVO));
        } else if (vo != null && vo.getBRoundPrice() == null && biddingProcessVO.getCRoundPrice() != null) {
            //未报价
            return Result.error("您上一轮没有报价，这一回合不能报价！");
        } else if (vo != null && vo.getBRoundPrice() != null && biddingProcessVO.getBRoundPrice() != null) {
            //第二轮重复
            return Result.error("您已经报过价了，不能重复报价");
        } else if (vo != null && vo.getCRoundPrice() != null && biddingProcessVO.getCRoundPrice() != null) {
            //第三轮重复
            return Result.error("您已经报过价了，不能重复报价");
        }
        return Result.error("您上一轮没有报价，这一回合不能报价！");
    }
}
