package com.gydx.service.impl;

import com.gydx.demo.SetId;
import com.gydx.mapper.BiddingMesMapper;
import com.gydx.mapper.BiddingProcessMapper;
import com.gydx.mapper.RuleManagementMapper;
import com.gydx.service.BiddingMesService;
import com.gydx.vo.BiddingMesVO;
import com.gydx.vo.BiddingProcessVO;
import com.gydx.vo.FoodRuleVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.Date;
import java.util.List;

@Service
public class BiddingMesImpl implements BiddingMesService {

    @Autowired
    BiddingMesMapper biddingMesMapper;

    @Autowired
    RuleManagementMapper ruleManagementMapper;

    @Autowired
    BiddingProcessMapper biddingProcessMapper;

    @Override
    public Integer saveBiddingMes(BiddingMesVO vo) {
        SetId setId = new SetId();

        vo.setBiddingMesID(setId.BiddingIdB());
        vo.setBiddingStatus("未开始");

        return biddingMesMapper.addBiddingMes(vo);
    }

    @Override
    public int removeBiddingMes(BiddingMesVO vo) {
        biddingMesMapper.deleteBiddingMes(vo);
        return 0;

    }

    @Override
    public int updateBiddingMes(BiddingMesVO vo) {
        biddingMesMapper.updateBiddingMes(vo);
        return 0;

    }

    @Override
    public List findBiddingMes(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMes(vo);
    }

    @Override
    public List findBiddingMesByName(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByName(vo);
    }

    @Override
    public List findBiddingMesByID(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByID(vo);
    }

    @Override
    public List findBiddingMesByStart(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByStart(vo);
    }

    @Override
    public List findBiddingMesByEnd(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByEnd(vo);
    }

    @Override
    public List findBiddingMesByInvoiceType(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByInvoiceType(vo);
    }

    @Override
    public List findBiddingMesByBiddingStatus(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByBiddingStatus(vo);
    }

    @Override
    public List findBiddingMesByPaymentTime(BiddingMesVO vo) {
        return biddingMesMapper.queryBiddingMesByPaymentTime(vo);
    }

    @Override
    public Integer endRoundBiddingMes(BiddingMesVO biddingMesVO) {
        //传递ID
        //依据ID查到订单所有信息
        List MesList = biddingMesMapper.queryBiddingMesByID(biddingMesVO);
        BiddingMesVO mesVo = (BiddingMesVO) MesList.get(0);
        //1.依据ID在Process里寻找最低值
        //1.1先依据规则id查找轮数
        FoodRuleVO foodVo = new FoodRuleVO();
        foodVo.setFoodRuleID(mesVo.getFoodRuleID());
        List ruleList = ruleManagementMapper.queryRuleByID(foodVo);
        FoodRuleVO foodVoTemp = (FoodRuleVO) ruleList.get(0);
        Integer round = foodVoTemp.getTotalRounds();
        //1.2依据轮数查找process表里的值，2查B，3查C
        //1.3依据找到的值互相比较，取最低值，取到最低值和对应Id
        BiddingProcessVO biddingProcessVO = new BiddingProcessVO();
        biddingProcessVO.setBiddingMesID(mesVo.getBiddingMesID());
        System.out.println("biddingProcessVO---------：" + biddingProcessVO.getBiddingMesID());
        List processList = biddingProcessMapper.queryAllByBiddingMesID(biddingProcessVO);
        final Integer[] minPrice = {999999};
        final String[] minId = {null};
        if (round == 2) {
            processList.forEach(item -> {
                BiddingProcessVO processVO = (BiddingProcessVO) item;
                if (processVO.getBRoundPrice() == null) {
                    return;
                }
                int currentPrice = Integer.parseInt(processVO.getBRoundPrice());
                if (currentPrice < minPrice[0]) {
                    minPrice[0] = currentPrice;  // 更新 minPrice 为当前最低价格
                    minId[0] = processVO.getFoodSupplierID();
                }
            });
        } else if (round == 3) {
            processList.forEach(item -> {
                BiddingProcessVO processVO = (BiddingProcessVO) item;
                if (processVO.getCRoundPrice() == null) {
                    return;
                }
                int currentPrice = Integer.parseInt(processVO.getCRoundPrice());
                if (currentPrice < minPrice[0]) {
                    minPrice[0] = currentPrice;  // 更新 minPrice 为当前最低价格
                    minId[0] = processVO.getFoodSupplierID();
                }
            });
        }
        //2.更新已完成状态和中标单位
        //2.1将中标单位ID和中标价格一并加入Mes表
        //最终结果
        String finalMinId = minId[0];
        Integer finalMinPrice = minPrice[0];
        //2.2返回完成
        if (finalMinPrice != 999999) {
            mesVo.setSupplierPrice(String.valueOf(finalMinPrice));
        }
        mesVo.setSupplierID(finalMinId);
        mesVo.setBiddingStatus("已结束");
        return biddingMesMapper.endRoundBiddingMes(mesVo);
    }


}
